import 'package:dao_wrapped/table/database_gateway.dart';
import 'package:example/model/sample_module.dart';
import 'package:sqflite/sqlite_api.dart';

class SampleGatewayTable implements DatabaseGateway<SampleModel> {
  @override
  final Database db;

  SampleGatewayTable(this.db);

  @override
  String get primaryId => "id";

  @override
  String get table => "SampleModel";

  Future createTable() async {
    var createTableRequest = "CREATE TABLE IF NOT EXISTS $table("
        "$primaryId INTEGER PRIMARY KEY,"
        "message TEXT)";
    await db.execute(createTableRequest);
    print(createTableRequest);
  }


  @override
  SampleModel fromMap(Map<String, dynamic> map) {
    return SampleModel.fromMap(map);
  }

  @override
  Map<String, dynamic> toMap(SampleModel model) {
    return model.toMap();
  }

}
