/// interface for bd table
abstract class Dao<T> {
  /// get by id
  Future<T> get(dynamic id);

  Future<List<T>> getAll();

  /// [filed] is filed name from [T]
  /// sample
  /// getByFields('name',13)
  Future<List<T>> getByField(String field, dynamic value);

  /// [fields] is filed name from [T]
  /// sample
  /// getByFields(['name','age'],['simon',13])
  Future<List<T>> getByFields(List<String> fields, List<dynamic> value);

  Future set(T model);

  Future setAll(List<T> models);

  Future update(T model);

  Future updateAll(List<T> models);

  /// wnl -with not null
  /// removed null keys from model map [toMapWithNotNull]
  Future updateWnl(T model);

  /// wnl -with not null
  /// removed null keys from model map [toMapWithNotNull]
  Future updateAllWnl(List<T> models);

  /// delete by id
  Future delete(dynamic id);

  Future deleteAll(List<dynamic> ids);

  Future clear();
//

}
