import 'package:dao_wrapped/dao/dao_mixin.dart';
import 'package:sqflite/sqflite.dart';

/// used in [DaoMixin]
abstract class DatabaseGateway<T> {
  Database get db;

  String get table;

  String get primaryId;

  Future createTable();

  /// map from bd
  T fromMap(Map<String, dynamic> map);

  /// map to bd
  Map<String, dynamic> toMap(T model);
}
